//+------------------------------------------------------------------+
//|                                                   Going Home.mq4 +
//|                              http://www.hopwood3.freeserve.co.uk +
//+------------------------------------------------------------------+
#property copyright ""
#property link      "http://www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define closelabelname "Close label"
#define stoplabelname "Stop label"
#define startlabelname "Start label"
#define  up "Market is trending up"
#define  down "Market is trending down"
#define  none "None"
#define  NL    "\n"

/*

I have only added some extra bells and whistles and multi-pair functionality to code already created
by smjones and roundrock. These two individuals deserve our thanks; without them, this robot would never have been born.
The bot attempts to trade Dreamliner's strategy at http://www.forexfactory.com/showthread.php?t=160912

double   cp(string Symbol1,string Symbol2,int TimeFrame, int periods)
double Correlation(double x[], double y[], int x_shift = 0, int y_shift = 0, int count = -1)
bool DoesTradeExist(int magic)
bool SendSingleTrade(string symbol, int type, string comment, double lotsize, double price, double stop, double take, int magic)
bool CloseAllTrades()
bool CheckTradingTimes()
void LookForTradeClosure()
bool IsTriple(string pair1, string pair2)
bool CheckForDuplicateTrade(string symbol)

//Pair extraction
void ExtractPairs()
void CleanUpInputString()
void CalculatePairsPassed()

ES tyrader
Great system. I have been trying this system on a demo for last 3 days. total profit 620 pips.

Basically I wait until diff is 80, then take the trade. If it goes to 90 add another contract and finally if it 
goes to dif of 100 add another contract.

Close position if it is in profit or wait until diff comes to 50
--------------------------------------------------------------------------------------------------

From T1minator, re stoch spikes
Would it be helpful to put in some hysteresis, not averaging that would just slow down the responsiveness, just so x number are above the threshold before the trade goes?

T
Something like this


if(MathAbs(stoch1-stoch2) > OpenTradeStoch && lastStochDiff > OpenTradeStoch)
{
................
}
LastStochDiff = MathAbs(stoch1-stoch2);


*/

extern string  GI="----General Inputs----";
extern string  PairsToTrade = "AUDCAD,AUDCHF,AUDNZD,AUDJPY,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURNZD,EURJPY,EURUSD,GBPAUD,GBPCAD,GBPCHF,GBPJPY,GBPNZD,GBPUSD,NZDUSD,NZDJPY,USDCAD,USDCHF,USDJPY";
extern double  Lot=0.1;
extern bool    UseDifferentialLotSize=false;
extern int     EmergencyTakeProfit=500;
extern int     EmergencyStopLoss=500;
extern int     SeedMagicNumber=9285783;
extern bool    CriminalIsECN=true;
extern int     MaxTradesAllowed=6;
extern int     MaxSpreadAllowed=150;
extern int     ButtonY=370;
extern bool    TrendTradeOnly=false;
extern bool    AllowClosureInLoss=false;
extern bool    ShowUserFeedback=true;
extern bool    AllowDuplicateTrades=false;
extern string  hp="----Hedged pairs----";
extern bool    SendPairTrade=true;
extern bool    UseScottHedgeFilter=true;
extern string  te="----Trade exit strategies----";
extern string  oc="Original CloseTradeStoch closure";
extern bool    CloseAtCloseTradeStoch=true;
extern string  pp="Combined pips profit";
extern bool    CloseAtCombinedPipsProfit=false;
extern int     CombinedPipsProfit=10;
extern string  pc="Combined cash profit";
extern bool    CloseAtCombinedCashProfit=false;
extern int     CombinedCashProfit=5;
extern string  dt="LoopDelayTimer: 1000 = 1 second";
extern int     LoopDelayTimer=1000;
extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Morning & Evening Hours";
extern string  Trade_Hoursi= "Use 24 hour, local time clock";
extern string  Trade_Hours_M= "Morning Hours 0-12";
extern  int    start_hourm = 0;
extern  int    end_hourm = 12;
extern string  Trade_Hours_E= "Evening Hours 12-24";
extern  int    start_houre = 12;
extern  int    end_houre = 24;
extern string  ci="----Correlation Inputs----";
extern int     CorrelationPeriods = 50;
extern int     CorrelationTimeFrame = 1440;
extern double  PositiveAbove = 75;
extern string  st="----Stochastic Inputs----";
extern int     K = 100;
extern int     D = 1;
extern int     S = 1;
extern string  StochTimeFrame_notes = "Timeframe M1=1, M5=5, M15=15, H1=60, H4=240, D1=1440";
extern int     StochTimeFrame = 5;
extern string  OpenTradeStoch_notes		= "Open Trade if stoch difference is above this number";
extern double  OpenTradeStoch =90;
extern string  CloseTradeStoch_notes		= "Close Trade if stoch difference is below this number";
extern double  CloseTradeStoch =20;


//Pair string variables
string         InputString;//Holds the contents PairsToTrade for tidying yp etc
int            NoOfPairs;// Holds the number of pairs passed by the user via the inputs screen
string         s[26];//Pairs
double         c[26][26];

int            SellTicketNo, BuyTicketNo;//Holds the OrderTicket() of an open trade - set by DoesTradeExist()
bool           RobotStopped = false;

//Stochastic
double         stoch1, stoch2; 


//Start/stop/close all labels
int            CloseButtonX = 200, CloseButtonY = 450;
int            StopButtonX = 350, StopButtonY = 450;
int            StartButtonX = 500, StartButtonY = 450;
bool           CloseNeeded;//Tells the bot that all trades must be closed

//Feedback display
bool           FirstTime = true;
string         ScreenMessage;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

void DisplayUserFeedback()
{

         
   string Gap = "                              ", feedback;
   //Show the user the ea is still working by displaying the time
   feedback = StringConcatenate(Gap, TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES|TIME_SECONDS), NL );
   if (RobotStopped) feedback = StringConcatenate(feedback, Gap, "Robot stopped. Continuing to monitor open trades for closure. ", NL );
      
   if (ShowUserFeedback && !RobotStopped && FirstTime)
   {
      FirstTime = false;
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trade pairs: ",StringSubstr(PairsToTrade, 0, 91), NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "                 ",StringSubstr(PairsToTrade, 92), NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot: ", Lot, NL);
      if (UseDifferentialLotSize) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Using differential lot sizing", NL);
      else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not using differential lot sizing", NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Emergency take profit: ", EmergencyTakeProfit, NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Emergency stop loss: ", EmergencyStopLoss, NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Seed magic number: ", SeedMagicNumber, NL);
      if (CriminalIsECN) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN = true", NL);
      else  ScreenMessage = StringConcatenate(ScreenMessage, Gap, "CriminalIsECN = false", NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "MaxTradesAllowed: ", MaxTradesAllowed, NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "MaxSpreadAllowed: ", MaxSpreadAllowed, NL);
      if (TrendTradeOnly) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "TrendTradeOnly = true", NL);
      else  ScreenMessage = StringConcatenate(ScreenMessage, Gap, "TrendTradeOnly = false", NL);
      if (AllowClosureInLoss) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AllowClosureInLoss = true", NL);
      else  ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AllowClosureInLoss = false", NL);
      if (AllowDuplicateTrades) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Allowing duplicate trades", NL);
      else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not allowing duplicate trades", NL);
      //Hedging
      if (SendPairTrade && UseScottHedgeFilter) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Sending hedged trade if it is part of a triple", NL);
      if (SendPairTrade && !UseScottHedgeFilter) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Sending hedged trade. Not using Scott's triple filter", NL);
      if (!SendPairTrade) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not sending a hedge", NL);
      
      //Trade exit
      ScreenMessage = StringConcatenate(ScreenMessage, NL);
      ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Exit strategies", NL);
      if (CloseAtCloseTradeStoch) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "      ", "CloseAtCloseTradeStoch = true", NL);
      else  ScreenMessage = StringConcatenate(ScreenMessage, Gap, "      ", "CloseAtCloseTradeStoch = false", NL);
      if (CloseAtCombinedPipsProfit) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "      ", 
                                     "CloseAtCombinedPipsProfit = true", ": CombinedPipsProfit = ", CombinedPipsProfit, NL);
      else  ScreenMessage = StringConcatenate(ScreenMessage, Gap, "      ", "CloseAtCombinedPipsProfit = false", NL);
      if (CloseAtCombinedCashProfit) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "      ", 
                                     "CloseAtCombinedCashProfit = true", ": CloseAtCombinedCashProfit = ", CombinedCashProfit, NL);
      else  ScreenMessage = StringConcatenate(ScreenMessage, Gap, "      ", "CloseAtCombinedCashProfit = false", NL);
      
      //Trading hours
      ScreenMessage = StringConcatenate(ScreenMessage, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Trading hours", NL);
      if (start_hourm == 0 && end_hourm == 12 && start_houre && end_houre == 24) ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            24H trading", NL);
      else
      {
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            start_hourm: ", DoubleToStr(start_hourm, 2), 
                         ": end_hourm: ", DoubleToStr(end_hourm, 2), NL);
         ScreenMessage = StringConcatenate(ScreenMessage,Gap, "            start_houre: ", DoubleToStr(start_houre, 2), 
                         ": end_houre: ", DoubleToStr(end_houre, 2), NL);
                      
      }//else

      //Correlation
      ScreenMessage = StringConcatenate(ScreenMessage, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Correlation", NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "      ", "Periods = ", CorrelationPeriods,
                      ":Time frame = ", CorrelationTimeFrame, ": PositiveAbove = ", PositiveAbove, NL);

/*
extern string  st="----Stochastic Inputs----";
extern int     K = 100;
extern int     D = 1;
extern int     S = 1;
extern string  StochTimeFrame_notes = "Timeframe M1=1, M5=5, M15=15, H1=60, H4=240, D1=1440";
extern int     StochTimeFrame = 5;
extern string  OpenTradeStoch_notes		= "Open Trade if stoch difference is above this number";
extern double  OpenTradeStoch =90;
extern string  CloseTradeStoch_notes		= "Close Trade if stoch difference is below this number";
extern double  CloseTradeStoch =20;

ScreenMessage = StringConcatenate(ScreenMessage, Gap, 
*/   

      //Stoch
      ScreenMessage = StringConcatenate(ScreenMessage, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Stochastic", NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "      ", "K = ", K,
                      ": D = ", D, ": S = ", S, ": StochTimeFrame = ", StochTimeFrame, NL);
      ScreenMessage = StringConcatenate(ScreenMessage,Gap, "      ", "OpenTradeStoch = ", OpenTradeStoch,
                      ": CloseTradeStoch = ", CloseTradeStoch, NL);
      


   }//if (ShowUserFeedback && !RobotStopped)
   
   Comment(feedback + ScreenMessage);
   
}//void DisplayUserFeedback()


int init()
{
//----
   
   /*
   //Define currency strings
   string m = StringSubstr(Symbol(),6,4);//Any pair suffix of any length up to 4
   s[0]="AUDCAD"+m;  s[1]="AUDCHF"+m;  s[2]="AUDJPY"+m;  s[3]="AUDNZD"+m;  s[4]="AUDUSD"+m;
   s[5]="CADJPY"+m;  s[6]="CHFJPY"+m;  s[7]="EURAUD"+m;  s[8]="EURCAD"+m;  s[9]="EURCHF"+m;
   s[10]="EURGBP"+m; s[11]="EURJPY"+m; s[12]="EURNZD"+m; s[13]="EURUSD"+m; s[14]="GBPAUD"+m; 
   s[15]="GBPCAD"+m; s[16]="GBPCHF"+m; s[17]="GBPJPY"+m; s[18]="GBPNZD"+m; s[19]="GBPUSD"+m;
   s[20]="NZDCHF"+m; s[21]="NZDJPY"+m; s[22]="NZDUSD"+m; s[23]="USDCAD"+m; s[24]="USDCHF"+m;
   s[25]="USDJPY"+m;     
   */
   
   
   //Adapt to x digit criminals
   int multiplier;
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   if(Digits == 7) multiplier = 1000;   
   
   
   EmergencyTakeProfit*= multiplier;
   EmergencyStopLoss*= multiplier;
   //CombinedPipsProfit*= multiplier;

  //Labels
  CloseButtonY = ButtonY;
  StopButtonY = ButtonY;
  StartButtonY = ButtonY;
  
  //Create a close immediately label
  ObjectDelete(closelabelname);
  ObjectCreate(closelabelname, OBJ_LABEL, 0, 0, 0);
  ObjectSet(closelabelname, OBJPROP_XDISTANCE, CloseButtonX);
  ObjectSet(closelabelname, OBJPROP_YDISTANCE, CloseButtonY);
  ObjectSetText(closelabelname, "Close all trades", 12, "Arial", Yellow);

  //Create a stop expert label
  ObjectDelete(stoplabelname);
  ObjectCreate(stoplabelname, OBJ_LABEL, 0, 0, 0);
  ObjectSet(stoplabelname, OBJPROP_XDISTANCE, StopButtonX);
  ObjectSet(stoplabelname, OBJPROP_YDISTANCE, StopButtonY);
  ObjectSetText(stoplabelname, "Stop the robot", 12, "Arial", Yellow);

  //Create a restart expert label
  ObjectDelete(startlabelname);
  ObjectCreate(startlabelname, OBJ_LABEL, 0, 0, 0);
  ObjectSet(startlabelname, OBJPROP_XDISTANCE, StartButtonX);
  ObjectSet(startlabelname, OBJPROP_YDISTANCE, StartButtonY);
  ObjectSetText(startlabelname, "Start the robot", 12, "Arial", Yellow);

   //Set up pairs list
   //GetAvailPairs();
   ExtractPairs();

   start();

//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
//----
   return(0);
}

void ExtractPairs()
{
   // Cleanup first
   InputString=PairsToTrade;
   CleanUpInputString();
   
   // Extract the number of paraaters passed by the user
   CalculatePairsPassed();
   
   string AddChar = StringSubstr(Symbol(),6,4);
   
   // Resize the array appropriately
   string sNewArray = ArrayResize(s, NoOfPairs);
   
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   int d;
   for (int cc = 0; cc < NoOfPairs; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         s[d] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         s[d] = StringTrimLeft(s[cc]);
         s[d] = StringTrimRight(s[cc]);
         s[d] = StringConcatenate(s[cc], AddChar);
         
         LastIndex = Index+1;
         
         //Allow for the pair not being one traded by the criminal
         //double ask = MarketInfo(s[d], MODE_ASK);
         //if (ask > 0) d++;     
         d++;
         
      }//if (Index > -1)            
   }//for (int cc; cc<NoOfPairs; cc ++)

   // Resize the array appropriately
   
   /*
   NoOfPairs = d;
   string sNewArray1 = ArrayResize(s, NoOfPairs);   
   Alert("Start");
   for (cc = 0; cc < NoOfPairs; cc ++)
   {
      Alert(s[cc]);
   }
   */
   
}//End void ExtractPairs()

bool CheckTradingTimes()
{
   int hour = TimeHour(TimeLocal() );
   
   if (end_hourm < start_hourm)
	{
		end_hourm += 24;
	}
	

	if (end_houre < start_houre)
	{
		end_houre += 24;
	}
	
	bool ok2Trade = true;
	
	ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);

	// adjust for past-end-of-day cases
	// eg in AUS, USDJPY trades 09-17 and 22-06
	// so, the above check failed, check if it is because of this condition
	if (!ok2Trade && hour < 12)
	{
 		hour += 24;
		ok2Trade = (hour >= start_hourm && hour <= end_hourm) || (hour >= start_houre && hour <= end_houre);		
		// so, if the trading hours are 11pm - 6am and the time is between  midnight to 11am, (say, 5am)
		// the above code will result in comparing 5+24 to see if it is between 23 (11pm) and 30(6+24), which it is...
	}


   // check for end of day by looking at *both* end-hours

   if (hour >= MathMax(end_hourm, end_houre))
   {      
      ok2Trade = false;
   }//if (hour >= MathMax(end_hourm, end_houre))

   return(ok2Trade);

}//bool CheckTradingTimes()


void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

void CalculatePairsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   NoOfPairs = 0;
   
   while(Index > -1)
      {
         Index = StringFind(InputString, ",",LastIndex);
         if (Index > -1)
         {
            NoOfPairs ++;
            LastIndex = Index+1;            
         }//if (Index > -1)
      }//while(int cc > -1)
   
   
   
}//End void CalculatePairsPassed()


double   cp(string Symbol1,string Symbol2,int TimeFrame, int periods)
{
	//Comment( Symbol1,"  ",Symbol2,"  ",TimeFrame,"  ",periods);
	datetime closeTime1	= iTime(Symbol1,TimeFrame,0),
				closeTime2	= iTime(Symbol2,TimeFrame,0),
				closeTime	= MathMin(closeTime1,closeTime2);
	int		shift1		= iBarShift(Symbol1,TimeFrame,closeTime),
				shift2		= iBarShift(Symbol2,TimeFrame,closeTime);
	double	Co,
	         close1[],
				close2[];

	ArrayCopySeries(close1,MODE_CLOSE,Symbol1,TimeFrame);
	ArrayCopySeries(close2,MODE_CLOSE,Symbol2,TimeFrame);

	int bars = MathMin(ArraySize(close1)-shift1,ArraySize(close2)-shift2);
	if ( periods > 0 )
	     bars = periods;
   Co = Correlation(close1,close2,shift1,shift2,bars);
   
   return(Co);
}//End double   cp(string Symbol1,string Symbol2,int TimeFrame, int periods)

//+------------------------------------------------------------------+
//| Correlation Coefficient R														|
//+------------------------------------------------------------------+
double Correlation(double x[], double y[], int x_shift = 0, int y_shift = 0, int count = -1)
{
	int n = MathMin(ArraySize(x)-x_shift,ArraySize(y)-y_shift);
	if(n>count && count>0)
		n=count;
	if(n<2)
		return(-2);

	double	sum_sq_x,
				sum_sq_y,
				sum_coproduct,
				mean_x = x[x_shift],
				mean_y = y[y_shift];

	for(int i = 0; i < n; i++)
	{
		double	sweep = i / (i+1.0),
					delta_x = x[i+x_shift] - mean_x,
					delta_y = y[i+y_shift] - mean_y;

		sum_sq_x += delta_x*delta_x * sweep;
		sum_sq_y += delta_y*delta_y * sweep;
    	sum_coproduct += delta_x*delta_y * sweep;
    	mean_x += delta_x / (i+1.0);
    	mean_y += delta_y / (i+1.0);
	}

	double	pop_sd_x = MathSqrt(sum_sq_x/n),
				pop_sd_y = MathSqrt(sum_sq_y/n),
				cov_x_y = sum_coproduct / n;

	if(pop_sd_x*pop_sd_y != 0.0)
		return(cov_x_y / (pop_sd_x*pop_sd_y));

	return(-3);
}//End double Correlation(double x[], double y[], int x_shift = 0, int y_shift = 0, int count = -1)

bool DoesTradeExist(int magic)
{
   
   SellTicketNo = 0;
   BuyTicketNo = 0;
   
   bool found = false;
   
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      
      if (OrderMagicNumber()==magic)      
      {
         if (OrderType() == OP_SELL) SellTicketNo = OrderTicket();
         if (OrderType() == OP_BUY) BuyTicketNo = OrderTicket();
         found = true;         
      }//if (OrderMagicNumber()==magic)
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)

   return(found);

}//End bool DoesTradeExist(int magic)

bool SendSingleTrade(string symbol, int type, string comment, double lotsize, double price, double stop, double take, int magic)
{
   
   
   int slippage = 10;
   if (MarketInfo(symbol, MODE_DIGITS) == 3 || MarketInfo(symbol, MODE_DIGITS) == 5) slippage = 100;
   
   
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);

   if (!CriminalIsECN) int ticket = OrderSend(symbol,type, lotsize, price, slippage, stop, take, comment, magic, expiry, CLR_NONE);
   
   
   //Is a 2 stage criminal
   if (CriminalIsECN)
   {
      bool result;
      int err;
      ticket = OrderSend(symbol,type, lotsize, price, slippage, 0, 0, comment, magic, expiry, CLR_NONE);
      if (ticket > 0)
      {
	     
	     if (take > 0 && stop > 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), stop, take, OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               Print(symbol, " SL/TP  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take > 0 && stop > 0)
      
	     if (take != 0 && stop == 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               Print(symbol, " SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take == 0 && stop != 0)

        if (take == 0 && stop != 0)
        {
           while(IsTradeContextBusy()) Sleep(100);
           result = OrderModify(ticket, OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);
           if (!result)
           {
               err=GetLastError();
               Print(symbol, " SL  order modify failed with error(",err,"): ",ErrorDescription(err));               
           }//if (!result)			  
        }//if (take == 0 && stop != 0)

      }//if (ticket > 0)
        
      
      
   }//if (CriminalIsECN)
   
   //Error trapping for both
   if (ticket < 0)
   {
      string stype;
      if (type == OP_BUY) stype = "OP_BUY";
      if (type == OP_SELL) stype = "OP_SELL";
      if (type == OP_BUYLIMIT) stype = "OP_BUYLIMIT";
      if (type == OP_SELLLIMIT) stype = "OP_SELLLIMIT";
      if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
      if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
      err=GetLastError();
      Alert(symbol, " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
      Print(symbol, " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
      return(false);
   }//if (ticket < 0)  
   
   //Force the bot to wait until the trade has registered with the platform
   while (!OrderSelect(ticket, SELECT_BY_TICKET) ) Sleep(100);
   //Got this far, so trade send succeeded
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)

bool CloseAllTrades()
{
  if (OrdersTotal() == 0) return (true);
  Comment("                   Closing the basket");

  bool success = true;

  for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
  {
    if (!OrderSelect(cc, SELECT_BY_POS)) continue;
    bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 5000, CLR_NONE);
    if (!result) success = false;
    if (result) cc++;
  } //for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)

  return (success);

} //End bool CloseAllTrades()

void LookForTradeClosure()
{
   //Examine the trade closure strategies and close trades if the criteria are met
   
   bool result, CloseSell, CloseBuy;
   int multiplier, digits;
   double Profit;

   ///////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Original CloseTradeStoch level closure
   if (CloseAtCloseTradeStoch)
   {
      if(MathAbs(stoch1-stoch2) < CloseTradeStoch) 
      {    
         if (AllowClosureInLoss)
         {
            if (OrderSelect(SellTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0) CloseSell = true;
            if (OrderSelect(BuyTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)CloseBuy = true;         
         }//if (AllowClosureInLoss)
         
         if (!AllowClosureInLoss)
         {
            Profit = 0;
            if (OrderSelect(SellTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0) Profit+= (OrderProfit() + OrderSwap() + OrderCommission() );
            if (OrderSelect(BuyTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0) Profit+= (OrderProfit() + OrderSwap() + OrderCommission() );
            if (Profit > 0)
            {
               CloseSell = true;
               CloseBuy = true;
            }//if (Profit > 0)
            
         }//if (!AllowClosureInLoss)
         
      }//if(MathAbs(stoch1-stoch2) < CloseTradeStoch)    
   }//if (CloseAtCloseTradeStoch)
   ///////////////////////////////////////////////////////////////////////////////////////////////////////////
   
   ///////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Combined pips profit closure
   if (CloseAtCombinedPipsProfit)
   {
      double PipsProfit;
      if (OrderSelect(SellTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)
      {
         digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
         if (digits == 2) multiplier = 100;
         if (digits == 3) multiplier = 1000;
         if (digits == 4) multiplier = 10000;
         if (digits == 5) multiplier = 100000;
         double bid = MarketInfo(OrderSymbol(), MODE_BID);
         PipsProfit = (OrderOpenPrice() - bid) * multiplier;
      }//if (OrderSelect(SellTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)
      
      if (OrderSelect(BuyTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)
      {
         double ask = MarketInfo(OrderSymbol(), MODE_ASK);
         digits = MarketInfo(OrderSymbol(), MODE_DIGITS);
         if (digits == 2) multiplier = 100;
         if (digits == 3) multiplier = 1000;
         if (digits == 4) multiplier = 10000;
         if (digits == 5) multiplier = 100000;
         Profit = (ask - OrderOpenPrice() ) * multiplier;
         PipsProfit+= Profit;
      }//if (OrderSelect(BuyTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)
   
      if (PipsProfit >= CombinedPipsProfit)
      {
         CloseSell = true;
         CloseBuy = true;
      }//if (PipsProfit >= CombinedPipsProfit)
      
   
   }//if (CloseAtCombinedPipsProfit)
   ///////////////////////////////////////////////////////////////////////////////////////////////////////////
   
   ///////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Combined cash profit closure
   if (CloseAtCombinedCashProfit)
   {
      Profit = 0;
      if (OrderSelect(SellTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)
      {
         Profit = OrderProfit() + OrderSwap() + OrderCommission();
      }//if (OrderSelect(SellTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)
   
      if (OrderSelect(BuyTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)
      {
         Profit+= (OrderProfit() + OrderSwap() + OrderCommission() );
      }//if (OrderSelect(SellTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)
   
      if (Profit >= CombinedCashProfit)
      {
         CloseSell = true;
         CloseBuy = true;
      }//if (Profit >= CombinedCashProfit)
      
   }//if (CloseAtCombinedCashProfit)
   

   ///////////////////////////////////////////////////////////////////////////////////////////////////////////


   ///////////////////////////////////////////////////////////////////////////////////////////////////////////
   //Do the closures
   if (CloseSell)
   {
      result = false;
      int tries = 0;
      if (OrderSelect(SellTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)
      {
         result = false;
         while (!result)
         {
            while (IsTradeContextBusy() ) Sleep(100);
            while (!IsConnected() ) Sleep(100);
            result = OrderClose(SellTicketNo, OrderLots(), OrderClosePrice(), 1000, CLR_NONE);
            tries++;
            if (tries == 100)
            {
               Alert("GH failed to close order no ", SellTicketNo);
            }//if (tries == 100)
            
         }//while (!result)
      }//if (OrderSelect(SellTicketNo, SELECT_BY_TICKET) & OrderCloseTime() == 0)      
   }//if (CloseSell)
   
   if (CloseBuy)
   {
      if (OrderSelect(BuyTicketNo, SELECT_BY_TICKET) && OrderCloseTime() == 0)
      {
         result = false;
         tries = 0;
         while (!result)
         {
            while (IsTradeContextBusy() ) Sleep(100);
            while (!IsConnected() ) Sleep(100);
            result = OrderClose(BuyTicketNo, OrderLots(), OrderClosePrice(), 1000, CLR_NONE);
            tries++;
            if (tries == 100)
            {
               Alert("GH failed to close order no ", SellTicketNo);
            }//if (tries == 100)
         }//while (!result)                        
      }//if (OrderSelect(SellTicketNo, SELECT_BY_TICKET) & OrderCloseTime() == 0)
   }//if (CloseBuy)
   

}//void LookForTradeClosure()

bool IsTriple(string pair1, string pair2)
{
      /*This function checks that the two pairs are part of a triple to allow some element of hedging.
      "Trade only positively correlated pairs with a total of 3 different currencies one of which 
      "MUST" be hedged ie: (Buy)EurCad (Sell)EurUsd. This way you are hedged for any risk event on EURO." 
      
      My thanks to Scott for coding this function
      */
      
      string c1 = StringSubstr(pair1,0,3);
      string c2 = StringSubstr(pair1,3,3);
      string c3 = StringSubstr(pair2,0,3);
      string c4 = StringSubstr(pair2,3,3);
      
      if( c1==c3 || c1==c4 || c2==c3 || c2==c4 || c3==c1 || c3==c2 || c4==c1 || c4==c2 )
         return(true);
         
      return(false);
}//End bool  IsTriple(string pair1, string pair2) 

/*
int GetAvailPairs() // Derived from code from 7bit
{
   //This function reads all available pairs into PairsToTrade, to automate the pair selection process.
   //Each pair needs comparing with the ExcludePairs list before being added.
   //The code is based on code contributed by KingHigh. Many thanks, KH.
   int i, SymRawHandle, PairCnt;
   SymRawHandle = FileOpenHistory("symbols.raw", FILE_BIN | FILE_READ);
   PairCnt = FileSize(SymRawHandle) / 1936;
   for (i = 0; i < PairCnt; i++)
   {
      string pair = StringTrimRight(StringTrimLeft(FileReadString(SymRawHandle, 12)));
      PairsToTrade = StringConcatenate(PairsToTrade, pair, ",");
      FileSeek(SymRawHandle, 1924, SEEK_CUR);
   }//for (i = 0; i < PairCnt; i++)
   FileClose(SymRawHandle);
}//End int GetAvailPairs()
*/

bool CheckForDuplicateTrade(string symbol)
{
   //Returns true if a pair already has a trade open from a different correlation difference group, else returns false
   
   if (OrdersTotal() == 0) return(false);
   
   for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   {
      if (!OrderSelect(cc,SELECT_BY_POS)) continue;
      if (OrderSymbol() == symbol) return(true);
   }//for (int cc = OrdersTotal() - 1; cc >= 0 ; cc--)
   
   //Got this far, so no duplicate trade
   return(false);

}//End bool CheckForDuplicateTrade(string symbol)


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   
   
   string CloseReason;
   bool result;
   //Loop around once a second
   static int LoopAround = 0;
   
   if (LoopAround == 1) return;//For testing only - not used for anything else
   
   while (IsExpertEnabled())
   {

    
      while (LoopAround == 0)
      {

         DisplayUserFeedback();
         int magic = SeedMagicNumber;
         
         Sleep(LoopDelayTimer);
         
         if (CloseNeeded)
         {
           Alert(CloseReason);
           bool CloseSuccess = false;
           while (!CloseSuccess)
           {
             CloseSuccess = CloseAllTrades();
           } //while (!CloseSuccess)
           CloseNeeded = false;        
         }//if (CloseNeeded)

         
         int count = ArraySize(s);
         for(int i = 0; i < count; i++)
         {
            if (MarketInfo(s[i], MODE_ASK) == 0) continue;
            if (!AllowDuplicateTrades)
            {
               if (CheckForDuplicateTrade(s[i]) ) continue;
            }//if (!AllowDuplicateTrades)
            
            for(int n = i + 1; n < count; n++, magic++)
            {
              //Alert(s[i], "  ", s[n]);
              //Respond to a move of the stop/start buttons
              if (MarketInfo(s[n], MODE_ASK) == 0) continue;
            
               if (!AllowDuplicateTrades)
               {
                  if (CheckForDuplicateTrade(s[n]) ) continue;
               }//if (!AllowDuplicateTrades)
            
              int labelx = ObjectGet(stoplabelname, OBJPROP_XDISTANCE);
              int labely = ObjectGet(stoplabelname, OBJPROP_YDISTANCE);
              if (labelx != StopButtonX || labely != StopButtonY)
              {
                Alert("Robot is stopped. Will continue to monitor the trades for closure");
                RobotStopped = true;
                ObjectSet(stoplabelname, OBJPROP_XDISTANCE, StopButtonX);
                ObjectSet(stoplabelname, OBJPROP_YDISTANCE, StopButtonY);
              } //if (labelx != StopButtonX || labely != StopButtonY) 

      
              labelx = ObjectGet(startlabelname, OBJPROP_XDISTANCE);
              labely = ObjectGet(startlabelname, OBJPROP_YDISTANCE);
              if (labelx != StartButtonX || labely != StartButtonY)
              {
                Alert("Robot has re-started");
                RobotStopped = false;
                ObjectSet(startlabelname, OBJPROP_XDISTANCE, StartButtonX);
                ObjectSet(startlabelname, OBJPROP_YDISTANCE, StartButtonY);
              } //if (labelx != StopButtonX || labely != StopButtonY) 

               
               //Spread check for hedged pairs
               if (SendPairTrade)
               {
                  double spread = MarketInfo(s[i], MODE_SPREAD);
                  if (spread > MaxSpreadAllowed) continue;
                  spread = MarketInfo(s[n], MODE_SPREAD);
                  if (spread > MaxSpreadAllowed) continue;
               }//if (SendPairTrade)
               
               

            
               //Calculate the correlation
               c[i][n]= 100*cp(s[i],s[n],CorrelationTimeFrame,CorrelationPeriods);
               //Alert(s[i], " ", s[n], c[i][n]);
            
               //Alert(s[i], "  ", s[n], "  ", c[i][n]);
         
               //Read the Stochastics
               stoch1 = iStochastic(s[i],StochTimeFrame,K,D,S,0,0,0,0); 
               stoch2 = iStochastic(s[n],StochTimeFrame,K,D,S,0,0,0,0); 
            
               //Look for an open trade
               bool TradeExists = false;
               if (OrdersTotal() > 0)
               {
                  TradeExists = DoesTradeExist(magic);

                  //Respond to a move of the close all trades button
                  labelx = ObjectGet(closelabelname, OBJPROP_XDISTANCE);
                  labely = ObjectGet(closelabelname, OBJPROP_YDISTANCE);
                  if (labelx != CloseButtonX || labely != CloseButtonY)
                  {
                    CloseReason = "Closing all trades.";
                    CloseNeeded = true;
                    ObjectSet(closelabelname, OBJPROP_XDISTANCE, CloseButtonX);
                    ObjectSet(closelabelname, OBJPROP_YDISTANCE, CloseButtonY);
                    return;
                  }//if (labelx != CloseButtonX || labely != CloseButtonY)

               }//if (OrdersTotal() > 0)
            
            
               /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
               //Look for open trade closure
               if (TradeExists)
               {
                  LookForTradeClosure();
               }//if (TradeExists)
                           
               /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
               //Trading times
               bool TradeTimeOk = CheckTradingTimes();
               if (!TradeTimeOk)
               {
                  Comment("Outside trading hours\nstart_hourm-end_hourm: ", start_hourm, "-",end_hourm, "\nstart_houre-end_houre: ", start_houre, "-",end_houre);
                  return;
               }//if (hour < start_hourm)
               /////////////////////////////////////////////////////////////////////////////////////////////////////////////////


               //Look for a trading opportunity
               if( c[i][n] >= PositiveAbove && c[i][n] < 99.99 && !TradeExists && OrdersTotal() < MaxTradesAllowed && !RobotStopped)
               {
                 // temp_p[pos]= s[i]+" | "+s[n]+"  "+DoubleToStr(c[i][n],0)+"   " +DoubleToStr(MathAbs(stoch1-stoch2),0)+" ";
              
                  
                  //temp_p[pos]= s[i]+" | "+s[n]+"  ";
              
                  if(MathAbs(stoch1-stoch2) > OpenTradeStoch) 
                  {
                     //Alert(s[i], "  ", stoch1, "  ", stoch2);
              
                     
                     //Sell trade
                     string sellSym = "", buySym = "";                     
                     if(stoch1 > stoch2)
                     { 
                        sellSym = s[i];
                        buySym = s[n];
                     }//if(stoch1 > stoch2)
                     
                     if(stoch1 < stoch2)
                     { 
                        sellSym=s[n];
                        buySym = s[i];
                     }//if(stoch1 < stoch2)
                  
                     //Spread check for non-hedge trade
                     spread = MarketInfo(sellSym, MODE_SPREAD);
                     if (spread > MaxSpreadAllowed) continue;
                  
                     //Trend definition
                     bool UpTrend = true;
                     bool DownTrend = true;
                     if (TrendTradeOnly)
                     {
                        double v = iRSI(buySym, 1440, 20, PRICE_CLOSE, 0);
                        if (v < 55) UpTrend = false;
                        v = iRSI(sellSym, 1440, 20, PRICE_CLOSE, 0);
                        if (v > 45) DownTrend = false;
                        if (!UpTrend || !DownTrend) continue;
                     }//if (TrendTradeOnly)
                     
                     
                     //'Emergency' Stop loss and tp
                     double stop, take;
                     double point = MarketInfo(sellSym, MODE_POINT);//Get Point for the pair
                     double digits = MarketInfo(sellSym, MODE_DIGITS);//Get Digits for the pair
                     //Bid
                     RefreshRates();
                     double bid = MarketInfo(sellSym, MODE_BID);
                     
                     
                     if (EmergencyStopLoss > 0)
                     {
                        stop = NormalizeDouble(bid + (EmergencyStopLoss * point), digits);
                     }//if (EmergencyStopLoss > 0)
                  
                     if (EmergencyTakeProfit > 0)
                     {
                        take = NormalizeDouble(bid - (EmergencyTakeProfit * point), digits);
                     }//if (EmergencyTakeProfit > 0)
                  
                  
                     //Send the trade
                     string comment = s[i] + " " + s[n];
                     //bool SendSingleTrade(string symbol, int type, string comment, double lotsize, double price, double stop, double take, int magic)
                     
                     //Calculate differential lot sizes
                     double SellLot = Lot, BuyLot = Lot;
                     if (UseDifferentialLotSize)
                     {                     
                        double tv1 = MarketInfo(sellSym, MODE_TICKVALUE);//TickValue 1 for sell pair
                        double tv2 = MarketInfo(buySym, MODE_TICKVALUE);//TickValue 2 for buy pair
                        double decimals = 2;//For 0.01 lotstep
                        if (MarketInfo(Symbol(), MODE_LOTSTEP) == 0.1) decimals = 1;
                        if (MarketInfo(Symbol(), MODE_LOTSTEP) == 1) decimals = 0;
                        double lotdif;
                        //Tick value for sell pair > for buy pair
                        if (tv1 > tv2)
                        {
                           lotdif = (tv1 / tv2);
                           BuyLot = NormalizeDouble(Lot * lotdif, decimals);                           
                        }//if (tv1 > tv2)
                        
                        //Tick value for buy pair > for sell pair
                        if (tv2 > tv1)
                        {
                           lotdif = (tv2 / tv1);
                           SellLot = NormalizeDouble(Lot * lotdif, decimals);                           
                        }//if (tv2 > tv1)
                        
                     }//if (UseDifferentialLotSize)
                     
                     //Hedge filter trade
                     //Check Scott's hedge filter first
                     bool HedgeAllowed = true;
                     if (UseScottHedgeFilter)
                     {
                        HedgeAllowed = IsTriple(sellSym, buySym);
                        if (!HedgeAllowed) continue;
                     }//if (UseScottHedgeFilter)
                     
                     if (DownTrend) result = SendSingleTrade(sellSym, OP_SELL, comment, SellLot, bid, stop, take, magic);
                  
                     /*
                     //Code for a successful trade Send
                     if (result)
                     {
                  
                  
                     }//if (result)
                     */
                     
                     //Code for a failed trade Send
                     if (!result)
                     {
                        //magic++;
                        continue;//Abort the hedge trade                  
                     }//if (!result)
                     
                  
                  
                     
                     if (SendPairTrade && HedgeAllowed)
                     {
                        //'Emergency' Stop loss and tp
                        point = MarketInfo(buySym, MODE_POINT);//Get Point for the pair
                        digits = MarketInfo(buySym, MODE_DIGITS);//Get Digits for the pair
                        //Ask
                        RefreshRates();
                        double ask = MarketInfo(buySym, MODE_ASK);
                     
                        
                        if (EmergencyStopLoss > 0)
                        {
                           stop = NormalizeDouble(ask - (EmergencyStopLoss * point), digits);
                        }//if (EmergencyStopLoss > 0)
                  
                        if (EmergencyTakeProfit > 0)
                        {
                           take = NormalizeDouble(ask + (EmergencyTakeProfit * point), digits);
                        }//if (EmergencyTakeProfit > 0)
                  
                  
                        //Send the trade
                        comment = s[i] + " " + s[n];
                        //bool SendSingleTrade(string symbol, int type, string comment, double lotsize, double price, double stop, double take, int magic)
                        if (UpTrend) result = SendSingleTrade(buySym, OP_BUY, comment, BuyLot, ask, stop, take, magic);
                  
                        /*
                        //Code for a successful trade Send
                        if (result)
                        {
                  
                  
                        }//if (result)
                  
                        //Code for a failed trade Send
                        if (!result)
                        {
                  
                  
                        }//if (!result)
                        */
                  
                     
                     }//if (SendPairTrade)
                     
                  
                  
                  }//if(MathAbs(stoch1-stoch2) > OpenTradeStoch)    

               }//if( c[i][n] >= PositiveAbove && c[i][n] < 99.99 && !TradeExists )
            
               
            }// end for n  
                   
         }//for(int n = i + 1; n <= count; n++, magic++)
 

      }//while (LoopAround == 0)
   }//while (IsExpertEnabled())
   
   return(0);
}
//+------------------------------------------------------------------+